=== debian/changelog ===
viennacl (1.1.2-6) unstable; urgency=low

  * Copyright info for CL/* external/pugixml/*

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 02 Aug 2011 10:30:34 +0200

viennacl (1.1.2-5) unstable; urgency=low

  * Fix regex in debian/watch
  * Remove generated files and re-generate when building
  * Link auxiliary/converter against libboost_system-mt
  * Force the Boost.Filesystem version 2 API for auxiliary/converter.cpp

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 02 Aug 2011 09:35:51 +0200

viennacl (1.1.2-4) unstable; urgency=low

  * Bump Standards-Version to 3.9.2

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 12 Jul 2011 19:45:08 +0200

viennacl (1.1.2-3) unstable; urgency=low

  * Use dpkg-mergechangelogs to merge debian/changelog
  * Build tests verbosely

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 05 Jul 2011 19:39:40 +0200

viennacl (1.1.2-2) unstable; urgency=low

  * Add patch to properly link against libOpenCL

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 05 Jul 2011 17:26:15 +0200

viennacl (1.1.2-1) unstable; urgency=low

  * Initial release (Closes: #620135)

 -- Michael Wild <themiwi@users.sourceforge.net>  Mon, 04 Jul 2011 16:14:19 +0200
