=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh --sourcedirectory=tests --builddirectory=tests/build $@

override_dh_auto_configure: custom_clean

override_dh_auto_build:
	@cd auxiliary && ./convert.sh
	@cd doc && doxygen
	@$(MAKE) -C doc/manual build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_configure
	dh_auto_build -- VERBOSE=1
	dh_auto_build -- ARGS="-VV" test || \
	  echo "== ONE OR MORE TESTS FAILED! =="
else
	@echo "== SKIPPING TESTS (nocheck in DEB_BUILD_OPTIONS) =="
endif

override_dh_install:
	dh_install
	mkdir debian/tmp
	pdftotext -f 47 -l 50 -nopgbrk -r 150                                 \
	  -x 130 -y 160 -W 980 -H 1440 -enc ASCII7                            \
	  doc/viennacl.pdf - |                                                \
	  sed -e 's/^Change Logs/= &\n/'                                      \
	      -e '/^Version [0-9]\.[0-9]\.x/d'                                \
	      -e 's/^Version [0-9]\./== &/'                                   \
	      -e '/^\* / i \ ' |                                              \
	  asciidoc -f /etc/asciidoc/text.conf - |                             \
	  lynx -dump --stdin > debian/tmp/changelog

custom_clean:
	@rm -f  auxiliary/converter
	@rm -f  auxiliary/generate-blas3-prod-align1
	@rm -f  auxiliary/generate-blas3-solve-align1
	@rm -rf CL
	@rm -rf doc/doxygen
	@rm -f  doc/viennacl.pdf
	@rm -f  doc/manual/*.bbl doc/manual/*.blg
	@rm -rf external
	@rm -rf viennacl/linalg/kernels/*
	@grep -rl 'file automatically generated' auxiliary/*/ | xargs rm -f
