=== debian/watch ===
version=3

http://sf.net/viennacl/ViennaCL-(\d.*)\.tar\.gz
