=== tests/CMakeLists.txt ===
foreach(PROG blas3 fft iterators matrix matrix_range scalar sparse structured-matrices vector vector_range)
   add_executable(${PROG}-test src/${PROG}.cpp)
   target_link_libraries(${PROG}-test ${OPENCL_LIBRARIES})
   add_test(${PROG} ${PROG}-test)
endforeach(PROG)

include_directories(${PROJECT_SOURCE_DIR}/external)
add_executable(external_linkage 
                src/external_1.cpp
                src/external_2.cpp 
                ${PROJECT_SOURCE_DIR}/external/pugixml/src/pugixml.cpp)
target_link_libraries(external_linkage ${OPENCL_LIBRARIES})
