=== examples/benchmarks/CMakeLists.txt ===
foreach(bench blas3 opencl vector)
   add_executable(${bench}bench ${bench}.cpp)
   target_link_libraries(${bench}bench ${OPENCL_LIBRARIES})
endforeach()

if(ENABLE_UBLAS)
   include_directories(${Boost_INCLUDE_DIRS})
   foreach(bench sparse solver)
      add_executable(${bench}bench ${bench}.cpp)
      target_link_libraries(${bench}bench ${OPENCL_LIBRARIES})
   endforeach()
endif()
