=== debian/changelog ===
viennacl (1.2.0-1) unstable; urgency=low

  * Make debian/copyright lintian clean
  * Improve debian/gbp.conf
  * New upstream version 1.2.0
  * Reworked packaging for new build system
  * Removed obsolete patches
  * Added 0001-Define-OPENCL_INCLUDE_DIRS-in-cmake-FindOpenCL.cmake.patch
  * Updated debian/watch file for appended -src suffix
  * Bump required cmake version to 2.8
  * Added get-orig-source target to debian/rules
  * Added 0002-Double-precision-on-AMD-GPUs-in-version-1.2.0.patch
  * Added 0003-Fix-adding-a-new-compute-device.patch
  * Update Standards-Version to 3.9.3

 -- Michael Wild <themiwi@users.sourceforge.net>  Mon, 27 Feb 2012 10:00:46 +0100
