=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Michael Wild <themiwi@users.sourceforge.net>
 Build-Depends: debhelper (>= 7.0.50~), poppler-utils, asciidoc, lynx,
- cmake (>= 2.6), libboost-filesystem-dev, texlive-latex-extra,
+ cmake (>= 2.8), libboost-filesystem-dev, texlive-latex-extra,
  texlive-latex-recommended, texlive-fonts-recommended, texlive-pstricks,
  ghostscript, doxygen, opencl-headers, libopencl1
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 DM-Upload-Allowed: yes
 Homepage: http://viennacl.sourceforge.net
 Vcs-Git: git://git.debian.org/git/debian-science/packages/viennacl.git
